export interface ConsumerAppConfig {
    consumer_key: string;
    consumer_secret: string;
    scope?: string;
    app_name: string;
}
export interface ProviderConfig {
    name: string;
    request_url: string;
    authorize_url: string;
    access_url: string;
}
export interface Store {
    getItem(key: string): string;
    setItem(key: string, value: string): any;
    removeItem(key: string): any;
}
export declare class OAuth {
    provider: ProviderConfig;
    consumer: ConsumerAppConfig;
    private store;
    __tempOAuthTokenSecret: string;
    __onSuccessResolveFunc: (token: {
        access_token: string;
        access_token_secret: string;
    }, done?: () => void) => unknown;
    constructor(provider: ProviderConfig, consumer: ConsumerAppConfig, store?: Store);
    getProviderAuthorizeURL(callback: string): Promise<URL>;
    private getOneTimeRequestToken;
    onAccessToken(token: {
        access_token: string;
        access_token_secret: string;
    }, done?: () => void): void;
    private storeKeyFor;
    private storeToken;
    getToken(): {
        access_token: string;
        access_token_secret: string;
    };
    hasToken(): boolean;
    clearToken(): void;
    /**
     * Send signed request by the same interface with window.fetch.
     * @param {RequestInfo} input
     * @param {RequestInit} init
     */
    fetch(input: RequestInfo, init?: RequestInit): Promise<Response>;
}
export declare enum SupportedProvider {
    Twitter = "twitter"
}
export declare class ProxyPage {
    private static callbackIdentifier;
    static extension: {
        getBackgroundPage(): Window;
    };
    static open(url: string, provider: SupportedProvider): Promise<unknown>;
    private static getOAuthObjectFromBackground;
    private url;
    private oauth;
    constructor(href?: string);
    onload(): Promise<void>;
    private redirectToProvider;
    private handleRequestToken;
}
